/* MIT License

Copyright (c) 2017 Adarsh Yoga and Santosh Nagarakatte, Rutgers University

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE. */

#ifndef AFTASK_H
#define AFTASK_H

#include "unique_task_id.H"

enum NodeType {
  NO_TYPE = 0,
  ASYNC = 1,
  FINISH = 2,
  STEP = 3
};

struct profiler_data {
  size_t work;
  size_t local_work;
  size_t critical_child;
  size_t parent_work;

  /**** CALCULATING %AGE OF CRITICAL PATH AND REGION ****/
  size_t local_local_work;
  std::unordered_map<size_t, size_t>* critical_call_sites;

  std::unordered_map<size_t, size_t>* region_work;
  /**** CALCULATING %AGE OF CRITICAL PATH REGION ****/
};

struct AFTask {
  bool sp_root_n_wt_flag;

  size_t parent;
  NodeType type;
  size_t num_children;

  /* profile data for each task */
  struct profiler_data t_prof;
  size_t call_site;
};

#endif
