/* MIT License

Copyright (c) 2017 Adarsh Yoga and Santosh Nagarakatte, Rutgers University

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE. */

#ifndef EXEC_CALLS_H
#define EXEC_CALLS_H

#pragma GCC push_options
#pragma GCC optimize ("O0")

#include "tbb/atomic.h"
#include "tbb/tbb_thread.h"

#include "AFTaskGraph.H"
#include "Task_Profiler.H"

typedef tbb::internal::tbb_thread_v3::id TBB_TID;

extern tbb::atomic<size_t> task_id_ctr;

extern tbb::atomic<size_t> tid_ctr;

extern AFTaskGraph* taskGraph;
extern Task_Profiler* taskProf;
extern Task_Logger* taskLogger;

#define __OPTIMIZE__BEGIN__ __optimize_begin__(__FILE__, __LINE__);
#define __OPTIMIZE__END__ __optimize_end__(__FILE__, __LINE__);

extern "C" {
  __attribute__((noinline)) void TD_Activate();

  __attribute__((noinline)) void Fini();

  __attribute__((noinline)) void __exec_begin__(unsigned long taskId);
  
  __attribute__((noinline)) void __exec_end__(unsigned long taskId);

  __attribute__((noinline)) void __optimize_begin__(const char* file, int line);

  __attribute__((noinline)) void __optimize_end__(const char* file, int line);

  size_t get_cur_tid( );
}

#pragma GCC pop_options

#endif
